//Includes:
#include <sourcemod>
#include <sdktools>

//Terminate:
#pragma semicolon 1

//Stocks:
#include "rp_stocks"

//Definitions:
#define	MAXDOORS 2000

//Paths:
static String:NamePath[64];



//setOwner:
public Action:CommandSetOwner(Client, Arguments)
{
    decl Ent;
    //Arguments:
    if(Arguments < 2)
    {

		//Print:
		PrintToConsole(Client, "[RP] Usage: sm_setnotice <Ent> <1|0 Save> <String>");

		//Return:
		return Plugin_Handled;
    }

    //Declare:
    decl String:Text[255],String:EntName[32],String:Saven[2],SavenBuffer;

    //Initialize:
    GetCmdArg(1, EntName, sizeof(EntName));
    GetCmdArg(2, Saven, sizeof(Saven));     
    GetCmdArg(3, Text, sizeof(Text));
    SavenBuffer = StringToInt(Saven);
    Ent = StringToInt(EntName);
	
    ServerCommand("sm_initnotice %d \"%s\"", Ent,Text);

    //Declare:
    decl Handle:Vault;
    new String:KeyBuffer[255];
    IntToString(Ent, KeyBuffer, 255);
        
    //Initialize:
    Vault = CreateKeyValues("Vault");

    if(StrEqual(Text, "null"))
    {
	FileToKeyValues(Vault, NamePath);
	//Delete:
	KvJumpToKey(Vault, "owner", false);
	KvDeleteKey(Vault, KeyBuffer); 
	KvRewind(Vault);
	KeyValuesToFile(Vault, NamePath);
	if(Client > 0)
	PrintToChat(Client, "[RP] Notice has been removed from Entity #%d.", Ent); 
    }
    else
    {
    if(SavenBuffer == 1)
    {
        //Retrieve:
        FileToKeyValues(Vault, NamePath);
	    SaveString(Vault, "owner", KeyBuffer, Text);
        //Store:
        KeyValuesToFile(Vault, NamePath);

	if(Client > 0)
        PrintToChat(Client, "[RP] Notice '%s' has been saved on Entity #%d.", Text, Ent);  
    } else 
    {
	if(Client > 0)
        PrintToChat(Client, "[RP] Notice '%s' has been temporary set on Entity #%d. %s %d", Text, Ent,Saven,SavenBuffer); 
    }
    }
    CloseHandle(Vault);
    return Plugin_Handled;
}


//Load Notices:
stock Load()
{

	//Declare:
	decl Handle:Vault;
	
	Vault = CreateKeyValues("Vault");
	
	//Load:
	FileToKeyValues(Vault, NamePath);


	//Declare:
	decl String:DoorId[255];
	decl String:Text[255];
	//Loop:
	for(new X = 0; X < MAXDOORS; X++)
	{
		//Convert:
		IntToString(X, DoorId, 255);
		LoadString(Vault, "owner", DoorId, "null", Text);
		if(!StrEqual(Text, "null", false))	
		{
		ServerCommand("sm_initnotice %d \"%s\"", X,Text);
		}
	}

	//Close:
	CloseHandle(Vault);
}

//Information:
public Plugin:myinfo =
{

	//Initation:
	name = "Message Giver",
	author = "Krim",
	description = "RP Info",
	version = "1.0",
	url = "wmchris.de"
}

public OnMapStart()
{
	Load();
}

//Initation:
public OnPluginStart()
{
	RegAdminCmd("sm_setnotice", CommandSetOwner, ADMFLAG_CUSTOM3, "<ent> <Name> - Sets the main owner of a door");

	//Name DB:
	BuildPath(Path_SM, NamePath, 64, "data/roleplay/notice.txt");
	if(FileExists(NamePath) == false) PrintToConsole(0, "[SM] ERROR: Missing file '%s'", NamePath);
	LoadTranslations("common.phrases");
	
}